#!/bin/bash

certs_dir=/var/pki/certs
periods_days=(1 7 14)
msg_recipient="admin@domain.com"
msg_subject="Истечение срока действия сертификата"
msg_body="Срок действия сертификата %s заканчивается %s"

for cert_path in $certs_dir/*.pem; do
    serial=$(openssl x509 -in $cert_path -serial -noout | sed -rn 's/serial=(.*)/\1/p')
    end_date_secs=$(date --date="$(openssl x509 -in $cert_path -enddate -noout | sed -rn 's/notAfter=(.*)/\1/p')" +%s)
    cur_date_secs=$(date +%s)
    dif_days=$((($end_date_secs-$cur_date_secs)/60/60/24))
    for period_days in ${periods_days[*]}; do
	if (($dif_days==$period_days)); then
	    msg_body_edited=$(printf "$msg_body" "$serial" "$(date --date=@$end_date_secs -u +'%d %b %Y %X %Z')")
	    mime-construct --to "$msg_recipient" --subject "$msg_subject" --string "$msg_body_edited"
	fi
    done
done
